from side import Side
import openpyxl


def merge(
        file1,
        file2,
        sheet1,
        sheet2,
        join_column,
        merge_cells,
        max_empty_rows=10,
        max_empty_columns=10,
        save_as=None,
        verbose=False,
        dry_run=False,
        override=False,
        highlight=False,
        debug=False
):
    # Init
    first = Side(file1, join_column, merge_cells, max_empty_rows, max_empty_columns, verbose, debug)
    first.workbook = openpyxl.load_workbook(file1)
    first.sheet = first.workbook.get_sheet_by_name(sheet1)
    second = Side(file2, join_column, merge_cells, max_empty_rows, max_empty_columns, verbose, debug)
    second.workbook = openpyxl.load_workbook(file2)
    second.sheet = second.workbook.get_sheet_by_name(sheet2)
    # Prepare
    first.find_join_id()
    second.find_join_id()
    first.find_merge_cells_id()
    second.find_merge_cells_id()
    # Export
    first.absorbe(second.export_all_cells(), override=override, highlight=highlight)
    # Save
    if not dry_run:
        save_name = save_as
        if save_name is None:
            save_name = file1
        first.log('Saving to file "{}"'.format(save_name), forced=True)
        first.workbook.save(save_name)


